import * as React from 'react';
import { Interpolation } from '@cloudflare/intl-core';
interface CommonTransProps {
    applyMarkdown?: boolean;
    smartCount?: number;
    _?: string;
    values?: {
        [interpolationKey: string]: any;
    };
    Components?: Array<React.ComponentType<any>>;
    componentProps?: Array<{
        [key: string]: any;
    }>;
}
interface TransPropsIdString extends CommonTransProps {
    id: string;
}
interface TransPropsIdInterpolation<Param extends string> extends CommonTransProps {
    id: Interpolation<Param>;
    values: {
        [K in Param]: string;
    };
}
export declare function Trans<Param extends string>({ id, smartCount, _, values, applyMarkdown, Components, componentProps }: TransPropsIdString | TransPropsIdInterpolation<Param>): JSX.Element;
export default Trans;
