/**
 * HOC that enhances your component with translator object.
 */
import { ComponentType } from 'react';
import { Translator } from '@cloudflare/intl-core';
import { Omit } from '@cloudflare/types';
export interface ITranslator {
    translator: Translator;
}
declare function withTranslator<T extends Partial<ITranslator>>(ComponentToWrap: ComponentType<T>): ComponentType<Omit<T, keyof ITranslator>>;
export default withTranslator;
