function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**
 * HOC that enhances your component with translator object.
 */
import React from 'react';
import { I18n } from './i18nContext';

function withTranslator(ComponentToWrap) {
  const WithTranslator = props => {
    return /*#__PURE__*/React.createElement(I18n, null, translator => {
      return /*#__PURE__*/React.createElement(ComponentToWrap, _extends({}, props, {
        translator: translator
      }));
    });
  };

  return WithTranslator;
}

export default withTranslator;