"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Trans = Trans;
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _escape = _interopRequireDefault(require("lodash/escape"));

var _utilMarkdown = _interopRequireDefault(require("@cloudflare/util-markdown"));

var _i18nContext = require("./i18nContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var tagRegex = /<(\d+)>(.*)<\/\1>|<(\d+)\/>/;
var newLineRegex = /(?:\r\n|\r|\n)/g;

function objectKeys(t) {
  return Object.keys(t);
}

function createElement(index, value) {
  return /*#__PURE__*/React.createElement("span", {
    key: index,
    dangerouslySetInnerHTML: {
      __html: value
    }
  });
}
/**
 * `formatElements` - parse string and return tree of react elements
 *
 * `value` is string to be formatted with <0>Paired<0/> or <0/> (unpaired)
 * placeholders. `Components` is a array of react Components which indexes
 * correspond to element indexes in formatted string
 */


function formatElements(value) {
  var Components = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var componentProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  // TODO: warn if there are any unprocessed elements
  // TODO: warn if element at `index` doesn't exist
  var treeIndex = 0;
  var parts = value.replace(newLineRegex, '').split(tagRegex); // If there are no inline elements, return value

  if (parts.length === 1) return [createElement(treeIndex, value)];
  var tree = [];
  var before = parts.shift();

  if (before) {
    var element = createElement(treeIndex, before);
    tree.push(element);

    if (typeof element !== 'string') {
      treeIndex++;
    }
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = getElements(parts)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _step$value = _slicedToArray(_step.value, 3),
          index = _step$value[0],
          children = _step$value[1],
          after = _step$value[2];

      if (!Components[index]) {
        window.console && console.warn("Missing Component for translation key: ".concat(value, ", index: ").concat(index, ". Fragment will be used."));
      }

      var Component = Components[index] || React.Fragment;
      var props = componentProps[index] || {};

      var _element = createElement(0, children);

      tree.push( /*#__PURE__*/React.createElement(Component, _extends({
        key: treeIndex
      }, props), _element));
      treeIndex++;

      if (after) {
        var _element2 = createElement(treeIndex, after);

        tree.push(_element2);

        if (typeof _element2 !== 'string') {
          treeIndex++;
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return tree;
}

/*
 * `getElements` - return array of element indexes and element childrens
 *
 * `parts` is array of [pairedIndex, children, unpairedIndex, textAfter, ...]
 * where:
 * - `pairedIndex` is index of paired element (undef for unpaired)
 * - `children` are children of paired element (undef for unpaired)
 * - `unpairedIndex` is index of unpaired element (undef for paired)
 * - `textAfter` is string after all elements (empty string, if there's nothing)
 *
 * `parts` length is always multiply of 4
 *
 * Returns: Array<[elementIndex, children, after]>
 */
function getElements(parts) {
  if (!parts.length) return [];

  var _parts$slice = parts.slice(0, 4),
      _parts$slice2 = _slicedToArray(_parts$slice, 4),
      paired = _parts$slice2[0],
      children = _parts$slice2[1],
      unpaired = _parts$slice2[2],
      after = _parts$slice2[3];

  var element = [[parseInt(paired || unpaired), children || '', after]];
  return element.concat(getElements(parts.slice(4, parts.length)));
}

function Trans(_ref) {
  var _ref$id = _ref.id,
      id = _ref$id === void 0 ? '' : _ref$id,
      smartCount = _ref.smartCount,
      _ = _ref._,
      values = _ref.values,
      applyMarkdown = _ref.applyMarkdown,
      Components = _ref.Components,
      componentProps = _ref.componentProps;
  return /*#__PURE__*/React.createElement(_i18nContext.I18n, null, function (translator) {
    // Ensure any interpolated values are escaped to prevent XSS and HTML injection
    if (values) {
      objectKeys(values).forEach(function (key) {
        return values[key] = (0, _escape.default)(values[key]);
      });
    } // Ensure any string props passed to React components are escaped to prevent potential XSS and HTML injection


    if (componentProps) {
      componentProps.forEach(function (props) {
        Object.keys(props).forEach(function (key) {
          if (typeof props[key] === 'string') {
            props[key] = (0, _escape.default)(props[key]);
          }
        });
      });
    }

    var options = _objectSpread({
      smart_count: smartCount,
      _: _
    }, values); // Skip built-in markdown sanitization, as all inputs are already sanitized above
    // Having another round of sanitization here would strip all <0 /> component interpolation tags


    var text = applyMarkdown ? (0, _utilMarkdown.default)(translator.t(id.toString(), options), {
      __dangerouslyDontSanitizeMarkdown: true
    }) : translator.t(id.toString(), options);
    var elements = formatElements(text, Components, componentProps);
    return elements.length > 1 ? /*#__PURE__*/React.createElement(React.Fragment, null, elements) : elements[0];
  });
}

var _default = Trans;
exports.default = _default;